#include <avr/wdt.h>
#include "TBMotor.h"

OseppTBMotor Motor1(12, 11);
OseppTBMotor Motor2(8, 3);
//OseppTBMotor Motor3(7, 6);
//OseppTBMotor Motor4(4, 5);

#define maxSpeed 255
#define leftMotor Motor1
#define rightMotor Motor2

int leftSpeed = 0;
int rightSpeed = 0;

void setup()
{
  BTInit();
  wdt_enable(WDTO_4S);
}

void ProcessCommand()
{
  char cmd;
  do {
    cmd = GetBTCmd();
    switch (cmd)
    {
      case 0: break; ////Repeat ,no cmd
      case 'U': case 'u':
        leftSpeed = rightSpeed = maxSpeed;
        break;
      case 'd':
        leftSpeed = rightSpeed = - maxSpeed;
        break;
      case 'L': case 'l':
        leftSpeed = -maxSpeed;
        rightSpeed = maxSpeed;
        break;
      case 'R': case 'r':
        leftSpeed = maxSpeed;
        rightSpeed = -maxSpeed;
        break;
      default:
        leftSpeed = rightSpeed = 0;
        break;
    }
  } while (cmd);
}


void loop()
{
  // check to see if the receiver has received
  // a command
  wdt_reset();
  ProcessCommand();
  SetMotor();
}

void SetMotor()
{
  if (leftSpeed > 255)leftSpeed = 255; else if (leftSpeed < -255)leftSpeed = -255;
  if (rightSpeed > 255)rightSpeed = 255; else if (rightSpeed < -255)rightSpeed = -255;
  leftMotor.SetSpeed(leftSpeed);
  rightMotor.SetSpeed(-rightSpeed);
}
