
#include "TBMotor.h"
#include "irfollower.h"


OseppTBMotor Motor1(12, 11);
OseppTBMotor Motor2(8, 3);
OseppTBMotor Motor3(7, 6);
OseppTBMotor Motor4(4, 5);


#define L Motor3
#define R Motor4

#define fwSpeed 100
#define fwTurnSpeed 100
#define softTurnSpeed 100

const int followD1 = A0;
const int followD2 = A1;
const int followD3 = A2;
const int followD4 = A3;
const int followD5 = A4;
// the leftmost IR Diode
const int followD6 = A5;

// Create our IR Follower object
IRFollower irFollower(followD1, followD2, followD3,
            followD4, followD5, followD6);


// the fastest the robot can go
const int maxSpeed = 100;
// the max and min +- input to driveDegrees
const int steeringMax = 90;

int leftSpeed = 0;
int rightSpeed = 0;
int clowSpeed = 0;

void steerDegrees(double deg)
{
  // if the angle is 0 or close to 0 drive forward
  if (deg > -1 && deg < 1)
  {
 leftSpeed = 75;
  rightSpeed = 75;
    // we don't need to do any more processing, end here
    return;
  }

  // use a linear equation to calculate the motor speed
  // required to turn
  double slope = ((double)maxSpeed * -1) / steeringMax;
  double turnMotorSpeed = (slope * abs(deg)) + maxSpeed;

  // if we're turning right
  if (deg > 1)
  {

  L.SetSpeed(turnMotorSpeed);
  R.SetSpeed(maxSpeed);
  
  }
  // if we're turning left
  else if (deg < 1)
  {
  L.SetSpeed(maxSpeed);
  R.SetSpeed(turnMotorSpeed);

   
  
  }

  
  
}

void setup() {
  
  Serial.begin(9600);

 


}

void loop()
{

  rotateBot();
  } //end program

void rotateBot(){
  

// read our sensor
  double deg = irFollower.readDegrees();

  // if there is no light
  if (deg == INTEGER_MIN)
  {
 L.SetSpeed(0);
  R.SetSpeed(0);
  }
  else
  {
    // steer it in the direction of the sensor
    steerDegrees(deg);
  }
  
  delay(1);
}
      
